﻿using System;
using System.Threading;
using System.Windows.Forms;
using BeeDevelopment.PlayJoy;

namespace PlayJoySharp {
	public partial class DemoInterface : Form {

		Controller Controller;
		DateTime LastSuccessfulUpdate;

		public DemoInterface() {
			InitializeComponent();
			this.Text = Application.ProductName;
			this.Controller = new BeeDevelopment.PlayJoy.Controller(0xCCD8);
			
		}

		private void Poller_Tick(object sender, EventArgs e) {

			Controller.Update();
			if (Controller.Connected) {
				this.EnabledPanel.Enabled = true;
				this.LastSuccessfulUpdate = DateTime.Now;
				float a = 2; float b = 5;
				this.LeftJoystick.X = Merge(this.LeftJoystick.X, Controller.LeftJoystick.X, a, b);
				this.LeftJoystick.Y = Merge(this.LeftJoystick.Y, Controller.LeftJoystick.Y, a, b);
				this.LeftJoystick.Pressed = (Controller.ButtonState & Controller.Buttons.L3) != Controller.Buttons.None;
				this.RightJoystick.X = Merge(this.RightJoystick.X, Controller.RightJoystick.X, a, b);
				this.RightJoystick.Y = Merge(this.RightJoystick.Y, Controller.RightJoystick.Y, a, b);
				this.RightJoystick.Pressed = (Controller.ButtonState & Controller.Buttons.R3) != Controller.Buttons.None;

				this.ButtonUp.Checked = (Controller.ButtonState & Controller.Buttons.Up) != Controller.Buttons.None;
				this.ButtonDown.Checked = (Controller.ButtonState & Controller.Buttons.Down) != Controller.Buttons.None;
				this.ButtonLeft.Checked = (Controller.ButtonState & Controller.Buttons.Left) != Controller.Buttons.None;
				this.ButtonRight.Checked = (Controller.ButtonState & Controller.Buttons.Right) != Controller.Buttons.None;

				this.ButtonTriangle.Checked = (Controller.ButtonState & Controller.Buttons.Triangle) != Controller.Buttons.None;
				this.ButtonSquare.Checked = (Controller.ButtonState & Controller.Buttons.Square) != Controller.Buttons.None;
				this.ButtonCircle.Checked = (Controller.ButtonState & Controller.Buttons.Circle) != Controller.Buttons.None;
				this.ButtonCross.Checked = (Controller.ButtonState & Controller.Buttons.Cross) != Controller.Buttons.None;

				this.ButtonL1.Checked = (Controller.ButtonState & Controller.Buttons.L1) != Controller.Buttons.None;
				this.ButtonL2.Checked = (Controller.ButtonState & Controller.Buttons.L2) != Controller.Buttons.None;
				this.ButtonR1.Checked = (Controller.ButtonState & Controller.Buttons.R1) != Controller.Buttons.None;
				this.ButtonR2.Checked = (Controller.ButtonState & Controller.Buttons.R2) != Controller.Buttons.None;

				this.ButtonSelect.Checked = (Controller.ButtonState & Controller.Buttons.Select) != Controller.Buttons.None;
				this.ButtonStart.Checked = (Controller.ButtonState & Controller.Buttons.Start) != Controller.Buttons.None;

				this.CheckAnalog.Checked = Controller.Analog;
			} else {
				if ((DateTime.Now - this.LastSuccessfulUpdate).TotalSeconds > 0.5) this.EnabledPanel.Enabled = false;
			}
			Thread.Sleep(20);
		}

		float Merge(float oldValue, float newValue, float ratioA, float ratioB) {
			return ((newValue * ratioA) + (oldValue * (ratioB - ratioA))) / ratioB;
		}
	}
}
